## tcc 0.9.26~git20110616.330d2ee

=== Makefile ===
#
# Tiny C Compiler Makefile
#

TOP ?= .
include $(TOP)/config.mak

CFLAGS+=-g -Wall
CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
LIBS_P=

ifneq ($(GCC_MAJOR),2)
CFLAGS+=-fno-strict-aliasing
ifneq ($(GCC_MAJOR),3)
CFLAGS+=-Wno-pointer-sign -Wno-sign-compare -D_FORTIFY_SOURCE=0
endif
endif

ifeq ($(ARCH),i386)
CFLAGS+=-mpreferred-stack-boundary=2
ifeq ($(GCC_MAJOR),2)
CFLAGS+=-m386 -malign-functions=0
else
CFLAGS+=-march=i386 -falign-functions=0
endif
endif

ifdef CONFIG_WIN64
CONFIG_WIN32=yes
endif

ifndef CONFIG_WIN32
LIBS=-lm
ifndef CONFIG_NOLDL
LIBS+=-ldl
endif
endif

ifeq ($(ARCH),i386)
NATIVE_DEFINES=-DTCC_TARGET_I386
else
ifeq ($(ARCH),x86-64)
NATIVE_DEFINES=-DTCC_TARGET_X86_64
NATIVE_DEFINES+=$(if $(wildcard /lib64/ld-linux-x86-64.so.2),-DTCC_TARGET_X86_64_CENTOS)
endif
endif

ifeq ($(ARCH),arm)
NATIVE_DEFINES=-DTCC_TARGET_ARM
NATIVE_DEFINES+=-DWITHOUT_LIBTCC
NATIVE_DEFINES+=$(if $(wildcard /lib/ld-linux.so.3),-DTCC_ARM_EABI)
NATIVE_DEFINES+=$(if $(shell grep -l "^Features.* \(vfp\|iwmmxt\) " /proc/cpuinfo),-DTCC_ARM_VFP)
endif

ifdef CONFIG_WIN32
NATIVE_DEFINES+=-DTCC_TARGET_PE
endif

ifneq ($(wildcard /lib/ld-uClibc.so.0),)
NATIVE_DEFINES+=-DTCC_UCLIBC
CONFIG_UCLIBC = 1
endif

# make libtcc as static or dynamic library?
ifdef DISABLE_STATIC
LIBTCC=libtcc.so.1.0
LINK_LIBTCC=-Wl,-rpath,"$(libdir)"
ifdef DISABLE_RPATH
LINK_LIBTCC=
endif
else
LIBTCC=libtcc.a
LINK_LIBTCC=
endif

ifeq ($(TOP),.)

PROGS=tcc$(EXESUF)
I386_CROSS = i386-tcc$(EXESUF)
WIN32_CROSS = i386-win32-tcc$(EXESUF)
WIN64_CROSS = x86_64-win32-tcc$(EXESUF)
WINCE_CROSS = arm-win32-tcc$(EXESUF)
X64_CROSS = x86_64-tcc$(EXESUF)
ARM_FPA_CROSS = arm-fpa-tcc$(EXESUF)
ARM_FPA_LD_CROSS = arm-fpa-ld-tcc$(EXESUF)
ARM_VFP_CROSS = arm-vfp-tcc$(EXESUF)
ARM_EABI_CROSS = arm-eabi-tcc$(EXESUF)
ARM_CROSS = $(ARM_FPA_CROSS) $(ARM_FPA_LD_CROSS) $(ARM_VFP_CROSS) $(ARM_EABI_CROSS)
C67_CROSS = c67-tcc$(EXESUF)

CORE_FILES = tcc.c libtcc.c tccpp.c tccgen.c tccelf.c tccasm.c tccrun.c
CORE_FILES += tcc.h config.h libtcc.h tcctok.h
I386_FILES = $(CORE_FILES) i386-gen.c i386-asm.c i386-asm.h i386-tok.h
WIN32_FILES = $(CORE_FILES) i386-gen.c i386-asm.c i386-asm.h i386-tok.h tccpe.c
WIN64_FILES = $(CORE_FILES) x86_64-gen.c i386-asm.c x86_64-asm.h tccpe.c
WINCE_FILES = $(CORE_FILES) arm-gen.c tccpe.c
X86_64_FILES = $(CORE_FILES) x86_64-gen.c i386-asm.c x86_64-asm.h
ARM_FILES = $(CORE_FILES) arm-gen.c
C67_FILES = $(CORE_FILES) c67-gen.c tcccoff.c

ifdef CONFIG_WIN64
PROGS+=tiny_impdef$(EXESUF) tiny_libmaker$(EXESUF)
NATIVE_FILES=$(WIN64_FILES)
PROGS_CROSS=$(WIN32_CROSS) $(I386_CROSS) $(X64_CROSS) $(ARM_CROSS) $(C67_CROSS)
LIBTCC1_CROSS=lib/i386-win32/libtcc1.a
LIBTCC1=libtcc1.a
else
ifdef CONFIG_WIN32
PROGS+=tiny_impdef$(EXESUF) tiny_libmaker$(EXESUF)
NATIVE_FILES=$(WIN32_FILES)
PROGS_CROSS=$(WIN64_CROSS) $(I386_CROSS) $(X64_CROSS) $(ARM_CROSS) $(C67_CROSS)
LIBTCC1_CROSS=lib/x86_64-win32/libtcc1.a
LIBTCC1=libtcc1.a
else
ifeq ($(ARCH),i386)
NATIVE_FILES=$(I386_FILES)
PROGS_CROSS=$(X64_CROSS) $(WIN32_CROSS) $(WIN64_CROSS) $(ARM_CROSS) $(C67_CROSS)
LIBTCC1_CROSS=lib/i386-win32/libtcc1.a lib/x86_64-win32/libtcc1.a
LIBTCC1=libtcc1.a
BCHECK_O=bcheck.o
else
ifeq ($(ARCH),x86-64)
NATIVE_FILES=$(X86_64_FILES)
PROGS_CROSS=$(I386_CROSS) $(WIN32_CROSS) $(WIN64_CROSS) $(ARM_CROSS) $(C67_CROSS)
LIBTCC1_CROSS=lib/i386-win32/libtcc1.a lib/x86_64-win32/libtcc1.a lib/i386/libtcc1.a
LIBTCC1=libtcc1.a
else
ifeq ($(ARCH),arm)
NATIVE_FILES=$(ARM_FILES)
PROGS_CROSS=$(I386_CROSS) $(X64_CROSS) $(WIN32_CROSS) $(WIN64_CROSS) $(C67_CROSS)
endif
endif
endif
endif
endif

ifdef CONFIG_UCLIBC
BCHECK_O=
endif

ifdef CONFIG_USE_LIBGCC
LIBTCC1=
endif

TCCLIBS = $(LIBTCC1) $(LIBTCC) $(BCHECK_O)
TCCDOCS = tcc.1 tcc-doc.html tcc-doc.info

ifdef CONFIG_CROSS
PROGS+=$(PROGS_CROSS)
TCCLIBS+=$(LIBTCC1_CROSS)
endif

all: $(PROGS) $(TCCLIBS) $(TCCDOCS)

# Host Tiny C Compiler
tcc$(EXESUF): tcc.o $(LIBTCC)
	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS) $(LINK_LIBTCC)

# Cross Tiny C Compilers
%-tcc$(EXESUF):
	$(CC) -o $@ tcc.c $(DEFINES) $(CFLAGS) $(LIBS) $(LDFLAGS)

$(I386_CROSS): DEFINES = -DTCC_TARGET_I386 -DCONFIG_TCCDIR="\"$(tccdir)/i386\""
$(X64_CROSS): DEFINES = -DTCC_TARGET_X86_64
$(WIN32_CROSS): DEFINES = -DTCC_TARGET_I386 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/32\""
$(WIN64_CROSS): DEFINES = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/64\""
$(WINCE_CROSS): DEFINES = -DTCC_TARGET_PE
$(C67_CROSS): DEFINES = -DTCC_TARGET_C67
$(ARM_FPA_CROSS): DEFINES = -DTCC_TARGET_ARM
$(ARM_FPA_LD_CROSS)$(EXESUF): DEFINES = -DTCC_TARGET_ARM -DLDOUBLE_SIZE=12
$(ARM_VFP_CROSS): DEFINES = -DTCC_TARGET_ARM -DTCC_ARM_VFP
$(ARM_EABI_CROSS): DEFINES = -DTCC_TARGET_ARM -DTCC_ARM_EABI

$(I386_CROSS): $(I386_FILES)
$(X64_CROSS): $(X86_64_FILES)
$(WIN32_CROSS): $(WIN32_FILES)
$(WIN64_CROSS): $(WIN64_FILES)
$(WINCE_CROSS): $(WINCE_FILES)
$(C67_CROSS): $(C67_FILES)
$(ARM_FPA_CROSS) $(ARM_FPA_LD_CROSS) $(ARM_VFP_CROSS) $(ARM_EABI_CROSS): $(ARM_FILES)

# libtcc generation and test
ifdef NOTALLINONE
LIBTCC_OBJ = $(filter-out tcc.o,$(patsubst %.c,%.o,$(filter %.c,$(NATIVE_FILES))))
LIBTCC_INC = $(filter %.h,$(CORE_FILES)) $(filter-out $(CORE_FILES),$(NATIVE_FILES))
$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DNOTALLINONE
else
LIBTCC_OBJ = libtcc.o
LIBTCC_INC = $(NATIVE_FILES)
tcc.o : NATIVE_DEFINES += -DNOTALLINONE
endif

$(LIBTCC_OBJ) tcc.o : %.o : %.c $(LIBTCC_INC)
	$(CC) -o $@ -c $< $(NATIVE_DEFINES) $(CFLAGS)

libtcc.a: $(LIBTCC_OBJ)
	$(AR) rcs $@ $^

libtcc.so.1.0: $(LIBTCC_OBJ)
	$(CC) -shared -Wl,-soname,$@ -o $@ $^

libtcc.so.1.0: CFLAGS+=-fPIC

# profiling version
tcc_p$(EXESUF): $(NATIVE_FILES)
	$(CC) -o $@ $< $(NATIVE_DEFINES) $(CFLAGS_P) $(LIBS_P)

# windows utilities
tiny_impdef$(EXESUF): win32/tools/tiny_impdef.c
	$(CC) -o $@ $< $(CFLAGS)
tiny_libmaker$(EXESUF): win32/tools/tiny_libmaker.c
	$(CC) -o $@ $< $(CFLAGS)

# TinyCC runtime libraries
libtcc1.a : FORCE
	@$(MAKE) -C lib native
lib/%/libtcc1.a : FORCE $(PROGS_CROSS)
	@$(MAKE) -C lib cross TARGET=$*
bcheck.o : lib/bcheck.c
	gcc -c $< -o $@ -O2 -Wall
FORCE:

# install
TCC_INCLUDES = stdarg.h stddef.h stdbool.h float.h varargs.h tcclib.h
INSTALL=install

ifndef CONFIG_WIN32
install: $(PROGS) $(TCCLIBS) $(TCCDOCS)
	mkdir -p "$(bindir)"
ifeq ($(CC),tcc)
	$(INSTALL) -m755 $(PROGS) "$(bindir)"
else
	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
endif
	mkdir -p "$(mandir)/man1"
	-$(INSTALL) tcc.1 "$(mandir)/man1"
	mkdir -p "$(infodir)"
	-$(INSTALL) tcc-doc.info "$(infodir)"
	mkdir -p "$(tccdir)"
	mkdir -p "$(tccdir)/include"
ifneq ($(LIBTCC1),)
	$(INSTALL) -m644 $(LIBTCC1) "$(tccdir)"
endif
ifneq ($(BCHECK_O),)
	$(INSTALL) -m644 $(BCHECK_O) "$(tccdir)"
endif
	$(INSTALL) -m644 $(addprefix include/,$(TCC_INCLUDES)) "$(tccdir)/include"
	mkdir -p "$(libdir)"
	$(INSTALL) -m755 $(LIBTCC) "$(libdir)"
ifdef DISABLE_STATIC
	ln -sf "$(ln_libdir)/libtcc.so.1.0" "$(libdir)/libtcc.so.1"
	ln -sf "$(ln_libdir)/libtcc.so.1.0" "$(libdir)/libtcc.so"
endif
	mkdir -p "$(includedir)"
	$(INSTALL) -m644 libtcc.h "$(includedir)"
	mkdir -p "$(docdir)"
	-$(INSTALL) -m644 tcc-doc.html "$(docdir)"
ifdef CONFIG_CROSS
	mkdir -p "$(tccdir)/win32/lib/32"
	mkdir -p "$(tccdir)/win32/lib/64"
ifeq ($(ARCH),x86-64)
	mkdir -p "$(tccdir)/i386"
	$(INSTALL) -m644 lib/i386/libtcc1.a "$(tccdir)/i386"
	cp -r "$(tccdir)/include" "$(tccdir)/i386"
endif
	$(INSTALL) -m644 win32/lib/*.def "$(tccdir)/win32/lib"
	$(INSTALL) -m644 lib/i386-win32/libtcc1.a "$(tccdir)/win32/lib/32"
	$(INSTALL) -m644 lib/x86_64-win32/libtcc1.a "$(tccdir)/win32/lib/64"
	cp -r win32/include/. "$(tccdir)/win32/include"
	cp -r include/. "$(tccdir)/win32/include"
endif

uninstall:
	rm -fv $(foreach P,$(PROGS),"$(bindir)/$P")
	rm -fv $(foreach P,$(LIBTCC1) $(BCHECK_O),"$(tccdir)/$P")
	rm -fv $(foreach P,$(TCC_INCLUDES),"$(tccdir)/include/$P")
	rm -fv "$(docdir)/tcc-doc.html" "$(mandir)/man1/tcc.1" "$(infodir)/tcc-doc.info"
	rm -fv "$(libdir)/$(LIBTCC)" "$(includedir)/libtcc.h"
	rm -fv "$(libdir)/libtcc.so*"
	rm -rf "$(tccdir)/win32"
	-rmdir $(tccdir)/include
ifeq ($(ARCH),x86-64)
	rm -rf "$(tccdir)/i386"
endif
else
# on windows
install: $(PROGS) $(TCCLIBS) $(TCCDOCS)
	mkdir -p "$(tccdir)"
	mkdir -p "$(tccdir)/lib"
	mkdir -p "$(tccdir)/include"
	mkdir -p "$(tccdir)/examples"
	mkdir -p "$(tccdir)/doc"
	mkdir -p "$(tccdir)/libtcc"
	$(INSTALL) -s -m755 $(PROGS) "$(tccdir)"
	$(INSTALL) -m644 $(LIBTCC1) win32/lib/*.def "$(tccdir)/lib"
	cp -r win32/include/. "$(tccdir)/include"
	cp -r win32/examples/. "$(tccdir)/examples"
	$(INSTALL) -m644 $(addprefix include/,$(TCC_INCLUDES)) "$(tccdir)/include"
	$(INSTALL) -m644 tcc-doc.html win32/tcc-win32.txt "$(tccdir)/doc"
	$(INSTALL) -m644 $(LIBTCC) libtcc.h "$(tccdir)/libtcc"
ifdef CONFIG_CROSS
	mkdir -p "$(tccdir)/lib/32"
	mkdir -p "$(tccdir)/lib/64"
	-$(INSTALL) -m644 lib/i386-win32/libtcc1.a "$(tccdir)/lib/32"
	-$(INSTALL) -m644 lib/x86_64-win32/libtcc1.a "$(tccdir)/lib/64"
endif

uninstall:
	rm -rfv "$(tccdir)/*"
endif

# documentation and man page
tcc-doc.html: tcc-doc.texi
	-texi2html -monolithic -number $<

tcc.1: tcc-doc.texi
	-./texi2pod.pl $< tcc.pod
	-pod2man --section=1 --center=" " --release=" " tcc.pod > $@

tcc-doc.info: tcc-doc.texi
	-makeinfo tcc-doc.texi

.PHONY: all clean tar distclean install uninstall FORCE

# tar release (use 'make -k tar' on a checkouted tree)
TCC-VERSION=tcc-$(shell cat VERSION)
tar:
	rm -rf /tmp/$(TCC-VERSION)
	cp -r . /tmp/$(TCC-VERSION)
	( cd /tmp ; tar zcvf ~/$(TCC-VERSION).tar.gz $(TCC-VERSION) --exclude CVS )
	rm -rf /tmp/$(TCC-VERSION)

# in tests subdir
export LIBTCC1

%est:
	$(MAKE) -C tests $@

clean:
	rm -vf $(PROGS) tcc_p$(EXESUF) tcc.pod *~ *.o *.a *.so* *.out *.exe libtcc_test$(EXESUF)
	$(MAKE) -C tests $@
ifneq ($(LIBTCC1),)
	$(MAKE) -C lib $@
endif

distclean: clean
	rm -vf config.h config.mak config.texi tcc.1 tcc-doc.info tcc-doc.html

config.mak:
	@echo "Please run ./configure."
	@exit 1

endif # ifeq ($(TOP),.)

=== tests/Makefile ===
#
# Tiny C Compiler Makefile - tests
#

# what tests to run
TESTS = libtest test3

# these should work too
# TESTS += test1 test2 speedtest btest weaktest

# these don't work as they should
# TESTS += test4 asmtest

TOP = ..
include $(TOP)/Makefile

ifdef DISABLE_STATIC
export LD_LIBRARY_PATH:=$(CURDIR)/..
endif

# run local version of tcc with local libraries and includes
TCC = ../tcc -B..
RUN_TCC = $(NATIVE_DEFINES) -run ../tcc.c -B..
DISAS=objdump -d

all test : $(TESTS)

# make sure that tcc exists
test1 test2 test3 test4 btest speedtest asmtest weaktest : ../tcc
../%:
	$(MAKE) -C .. $*

# libtcc test
ifdef LIBTCC1
LIBTCC1:=$(TOP)/$(LIBTCC1)
endif

libtest: libtcc_test$(EXESUF) $(LIBTCC1)
	@echo ------------ $@ ------------
	./libtcc_test$(EXESUF) lib_path=..

libtcc_test$(EXESUF): libtcc_test.c ../$(LIBTCC)
	$(CC) -o $@ $^ -I.. $(CFLAGS) $(LIBS) $(LINK_LIBTCC)

# test.ref - generate using gcc
# copy only tcclib.h so GCC's stddef and stdarg will be used
test.ref: tcctest.c
	cp -u ../include/tcclib.h .
	$(CC) -o tcctest.gcc $< -I. -w $(CFLAGS) -std=gnu99
	./tcctest.gcc > $@

# auto test
test1: test.ref
	@echo ------------ $@ ------------
	$(TCC) -run tcctest.c > test.out1
	@if diff -u test.ref test.out1 ; then echo "Auto Test OK"; fi

# iterated test2 (compile tcc then compile tcctest.c !)
test2: test.ref
	@echo ------------ $@ ------------
	$(TCC) $(RUN_TCC) $(RUN_TCC) -run tcctest.c > test.out2
	@if diff -u test.ref test.out2 ; then echo "Auto Test2 OK"; fi

# iterated test3 (compile tcc then compile tcc then compile tcctest.c !)
test3: test.ref
	@echo ------------ $@ ------------
	$(TCC) $(RUN_TCC) $(RUN_TCC) $(RUN_TCC) -run tcctest.c > test.out3
	@if diff -u test.ref test.out3 ; then echo "Auto Test3 OK"; fi

# binary output test
test4: test.ref
	@echo ------------ $@ ------------
# dynamic output
	$(TCC) -o tcctest1 tcctest.c
	./tcctest1 > test1.out
	@if diff -u test.ref test1.out ; then echo "Dynamic Auto Test OK"; fi
# object + link output
	$(TCC) -c -o tcctest3.o tcctest.c
	$(TCC) -o tcctest3 tcctest3.o
	./tcctest3 > test3.out
	@if diff -u test.ref test3.out ; then echo "Object Auto Test OK"; fi
# static output
	$(TCC) -static -o tcctest2 tcctest.c
	./tcctest2 > test2.out
	@if diff -u test.ref test2.out ; then echo "Static Auto Test OK"; fi
# dynamic output + bound check
	$(TCC) -b -o tcctest4 tcctest.c
	./tcctest4 > test4.out
	@if diff -u test.ref test4.out ; then echo "BCheck Auto Test OK"; fi

# memory and bound check auto test
BOUNDS_OK  = 1 4 8 10 14
BOUNDS_FAIL= 2 5 7 9 11 12 13 15

btest: boundtest.c ../bcheck.o
	@echo ------------ $@ ------------
	@for i in $(BOUNDS_OK); do \
	   echo ; echo --- boundtest $$i ---; \
	   if $(TCC) -b -run boundtest.c $$i ; then \
	       echo succeded as expected; \
	   else\
	       echo Failed positive test $$i ; exit 1 ; \
	   fi ;\
	done ;\
	for i in $(BOUNDS_FAIL); do \
	   echo ; echo --- boundtest $$i ---; \
	   if $(TCC) -b -run boundtest.c $$i ; then \
	       echo Failed negative test $$i ; exit 1 ;\
	   else\
	       echo failed as expected; \
	   fi ;\
	done ;\
	echo; echo Bound test OK

# speed test
speedtest: ex2 ex3
	@echo ------------ $@ ------------
	time ./ex2 1238 2 3 4 10 13 4
	time $(TCC) -run ../examples/ex2.c 1238 2 3 4 10 13 4
	time ./ex3 35
	time $(TCC) -run ../examples/ex3.c 35

weaktest: test.ref
	$(TCC) -c tcctest.c -o weaktest.tcc.o
	 $(CC) -c tcctest.c -o weaktest.gcc.o -I. -w $(CFLAGS)
	objdump -t weaktest.tcc.o | grep ' w ' | sed -e 's/.* \([a-zA-Z0-9_]*\)$$/\1/' | LC_ALL=C sort > weaktest.tcc.o.txt
	objdump -t weaktest.gcc.o | grep ' w ' | sed -e 's/.* \([a-zA-Z0-9_]*\)$$/\1/' | LC_ALL=C sort > weaktest.gcc.o.txt
	diff weaktest.gcc.o.txt weaktest.tcc.o.txt && echo "Weak Auto Test OK"

ex%: ../examples/ex%.c
	$(CC) -o $@ $< $(CFLAGS)

# tiny assembler testing
asmtest.ref: asmtest.S
	$(CC) -Wa,-W -o asmtest.ref.o -c asmtest.S
	objdump -D asmtest.ref.o > asmtest.ref

asmtest: asmtest.ref
	@echo ------------ $@ ------------
	$(TCC) -c asmtest.S
	objdump -D asmtest.o > asmtest.out
	@if diff -u --ignore-matching-lines="file format" asmtest.ref asmtest.out ; then echo "ASM Auto Test OK"; fi

# targets for development
%.bin: %.c tcc
	$(TCC) -g -o $@ $<
	$(DISAS) $@

instr: instr.o
	objdump -d instr.o

instr.o: instr.S
	$(CC) -o $@ -c $< -O2 -Wall -g

cache: tcc_g
	cachegrind ./tcc_g -o /tmp/linpack -lm bench/linpack.c
	vg_annotate tcc.c > /tmp/linpack.cache.log

# clean
clean:
	rm -vf *~ *.o *.a *.bin *.i *.ref *.out *.out? *.gcc \
	   tcctest[1234] ex? libtcc_test$(EXESUF) tcc_g tcclib.h

=== debian/changelog ===
tcc (0.9.26~git20110616.330d2ee-4) experimental; urgency=low

  * Replace old patch fixing Hurd FTBFS by the one accepted upstream.
  * Insert missing changelog for tcc 0.9.25-9.
  * Stop wrongly using multiarch dynamic loader as elf interpreter (eg. back
    to use /lib64/ld-linux-x86-64.so.2 for amd64).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 31 Jul 2011 21:43:49 +0200

tcc (0.9.26~git20110616.330d2ee-3) experimental; urgency=low

  * Use any-i386 and any-amd64 instead of hardcoded list of architectures.
  * Fix Hurd FTBFS by forcing expr_cond to only consider constant expression
    outside functions.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 31 Jul 2011 13:49:20 +0200

tcc (0.9.25-9) unstable; urgency=low

  * Stop exporting tcc_add_file2(), tcc_add_sysfile() and
    tcc_add_syslibrary_path() functions added for multiarch transitions.
  * Use any-i386 and any-amd64 instead of hardcoded list of architectures.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 24 Jul 2011 21:27:09 +0200

tcc (0.9.26~git20110616.330d2ee-2) experimental; urgency=low

  * Don't define strtof and strtold on Debian GNU/kFreeBSD (fix FTBFS).

 -- Thomas Preud'homme <robotux@celest.fr>  Fri, 15 Jul 2011 18:16:26 +0200

tcc (0.9.26~git20110616.330d2ee-1) experimental; urgency=low

  * New upstream snapshot:
    + Fix design of previous VLA implementation
    + Allow jumps > 32MB for -run on ARM. (Closes: #592618)

  * debian/patches:
    + Remove all merged patches
    + Add 0001-Default-to-create-progs-with-symbols-incl.-debug.patch:
      create unstripped program with debug infos.
    + Add 0002-Make-ex1.c-and-ex4.c-be-executable-on-any-systems.patch

  * debian/copyright:
    + document origin of source code.

  * debian/rules:
    + Use dpkg-buildflags to set build flags (CPPFLAGS, CFLAGS and LDFLAGS).
    + Only call dh_auto_clean if config.mak exists.
    + Keep tcc directory in /usr/lib/tcc.

  * Point Vcs-* to anonscm.debian.org.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 12 Jul 2011 16:59:57 +0200

tcc (0.9.25-8) unstable; urgency=low

  * Modify debian/rules to use patch added in 0.9.25-7 (Closes: #632089).
  * Get DEB_HOST_MULTIARCH from dpkg-architecture to ensure it is set when
    calling debian/rules manually.
  * Fix build failure on i386: array_test should not define any parameter.
  * Make patch for multilib consistent with regards to the filenames opened.

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 11 Jul 2011 14:22:57 +0200

tcc (0.9.25-7) unstable; urgency=medium (fix #632089)

  * Search system files and library in multilib path (Closes: #632089).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 10 Jul 2011 17:22:36 +0200

=== debian/control ===
Source: tcc
Section: devel
Priority: optional
Maintainer: Aurélien GÉRÔME <ag@debian.org>
Uploaders: Thomas Preud'homme <robotux@celest.fr>, Arthur Loiret <arthur.loiret@gmail.com>
Build-Depends: debhelper (>= 8.1.3), texi2html, texinfo, perl
Standards-Version: 3.9.2
Homepage: http://www.tinycc.org/
DM-Upload-Allowed: yes
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/tcc.git
Vcs-Git: git://anonscm.debian.org/collab-maint/tcc.git

Package: tcc
Architecture: any-i386 any-amd64 armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Provides: c-compiler
Description: Small ANSI C compiler
 TCC (for Tiny C Compiler) is a small and fast ANSI C compiler.  It
 generates optimized x86 code, and can compile, assemble, and link
 several times faster than 'gcc -O0'.  Any C dynamic library can be used
 directly.  It includes an optional memory and bounds checker, and
 bounds-checked code can be mixed freely with standard code.  C script
 is also supported via the usual hash-bang mechanism.
 .
 NOTE: TCC is still somewhat experimental and is not recommended for
 production use.  The code it generates is much less optimized than what
 GCC produces, and compiler bugs can have serious security consequences
 for your program.

Package: libtcc-dev
Section: libdevel
Architecture: any-i386 any-amd64 armel
Depends: ${misc:Depends}
Description: Fast library for dynamic code generation
 Libtcc is a library that uses tcc, a compiler several times faster than
 'gcc -O0' to perform dynamic code generation. It exposes in its API all
 operations tcc performs to generate a binary from sources: setting
 header and library paths, compiling program from a source file,
 manipulating its symbols and handling relocation of its code among
 other things. Libtcc is also able to compile from a buffer.
 .
 This package contains the static library and header file for TCC (Tiny
 C Compiler).
 .
 NOTE: libtcc is still somewhat experimental and is not recommended for
 production use.  The code it generates is much less optimized than what
 GCC produces, and compiler bugs can have serious security consequences
 for your program.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	[ ! -f config.mak ] || dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --tccdir=../tcc --multilib-subdir=$(DEB_HOST_MULTIARCH)

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build # As recommended by policy §4.9

%:
	dh $@

## tcc 0.9.26~git20120104.83d57c0

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,6 @@
 TOP ?= .
 include $(TOP)/config.mak
 
-CFLAGS+=-g -Wall
 CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
 LIBS_P=
 
@@ -158,12 +157,17 @@
 
 # Cross Tiny C Compilers
 %-tcc$(EXESUF):
-	$(CC) -o $@ tcc.c $(DEFINES) $(CFLAGS) $(LIBS) $(LDFLAGS)
-
-$(I386_CROSS): DEFINES = -DTCC_TARGET_I386 -DCONFIG_TCCDIR="\"$(tccdir)/i386\""
+	$(CC) -o $@ tcc.c -DONE_SOURCE $(DEFINES) $(CFLAGS) $(LIBS) $(LDFLAGS)
+
+$(I386_CROSS): DEFINES = -DTCC_TARGET_I386 \
+    -DCONFIG_TCCDIR="\"$(tccdir)/i386\""
 $(X64_CROSS): DEFINES = -DTCC_TARGET_X86_64
-$(WIN32_CROSS): DEFINES = -DTCC_TARGET_I386 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/32\""
-$(WIN64_CROSS): DEFINES = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/64\""
+$(WIN32_CROSS): DEFINES = -DTCC_TARGET_I386 -DTCC_TARGET_PE \
+    -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" \
+    -DCONFIG_TCC_LIBPATHS="\"{B}/lib/32;{B}/lib\""
+$(WIN64_CROSS): DEFINES = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE \
+    -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" \
+    -DCONFIG_TCC_LIBPATHS="\"{B}/lib/64;{B}/lib\""
 $(WINCE_CROSS): DEFINES = -DTCC_TARGET_PE
 $(C67_CROSS): DEFINES = -DTCC_TARGET_C67
 $(ARM_FPA_CROSS): DEFINES = -DTCC_TARGET_ARM
@@ -180,14 +184,13 @@
 $(ARM_FPA_CROSS) $(ARM_FPA_LD_CROSS) $(ARM_VFP_CROSS) $(ARM_EABI_CROSS): $(ARM_FILES)
 
 # libtcc generation and test
-ifdef NOTALLINONE
+ifndef ONE_SOURCE
 LIBTCC_OBJ = $(filter-out tcc.o,$(patsubst %.c,%.o,$(filter %.c,$(NATIVE_FILES))))
 LIBTCC_INC = $(filter %.h,$(CORE_FILES)) $(filter-out $(CORE_FILES),$(NATIVE_FILES))
-$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DNOTALLINONE
 else
 LIBTCC_OBJ = libtcc.o
 LIBTCC_INC = $(NATIVE_FILES)
-tcc.o : NATIVE_DEFINES += -DNOTALLINONE
+$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DONE_SOURCE
 endif
 
 $(LIBTCC_OBJ) tcc.o : %.o : %.c $(LIBTCC_INC)
@@ -217,12 +220,17 @@
 lib/%/libtcc1.a : FORCE $(PROGS_CROSS)
 	@$(MAKE) -C lib cross TARGET=$*
 bcheck.o : lib/bcheck.c
-	gcc -c $< -o $@ -O2 -Wall
+	gcc -c $< -o $@ $(CFLAGS)
 FORCE:
 
 # install
 TCC_INCLUDES = stdarg.h stddef.h stdbool.h float.h varargs.h tcclib.h
 INSTALL=install
+ifdef STRIP_BINARIES
+INSTALLBIN=$(INSTALL) -s
+else
+INSTALLBIN=$(INSTALL)
+endif
 
 ifndef CONFIG_WIN32
 install: $(PROGS) $(TCCLIBS) $(TCCDOCS)
@@ -230,7 +238,7 @@
 ifeq ($(CC),tcc)
 	$(INSTALL) -m755 $(PROGS) "$(bindir)"
 else
-	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
+	$(INSTALLBIN) -m755 $(PROGS) "$(bindir)"
 endif
 	mkdir -p "$(mandir)/man1"
 	-$(INSTALL) tcc.1 "$(mandir)/man1"
@@ -291,7 +299,7 @@
 	mkdir -p "$(tccdir)/examples"
 	mkdir -p "$(tccdir)/doc"
 	mkdir -p "$(tccdir)/libtcc"
-	$(INSTALL) -s -m755 $(PROGS) "$(tccdir)"
+	$(INSTALLBIN) -m755 $(PROGS) "$(tccdir)"
 	$(INSTALL) -m644 $(LIBTCC1) win32/lib/*.def "$(tccdir)/lib"
 	cp -r win32/include/. "$(tccdir)/include"
 	cp -r win32/examples/. "$(tccdir)/examples"

=== lib/Makefile ===
#
# Tiny C Compiler Makefile for libtcc1.a
#

TOP = ..
include $(TOP)/config.mak

ifndef TARGET
 ifdef CONFIG_WIN64
  TARGET = x86_64-win32
 else
 ifdef CONFIG_WIN32
  TARGET = i386-win32
 else
 ifeq ($(ARCH),i386)
  TARGET = i386
  XCC = gcc -O2
 else
 ifeq ($(ARCH),x86-64)
  TARGET = x86_64
  XCC = gcc -O2
 endif
 endif
 endif
 endif
endif

DIR = $(TARGET)

native : ../libtcc1.a
cross : $(DIR)/libtcc1.a

native : TCC = $(TOP)/tcc$(EXESUF)
cross : TCC = $(TOP)/$(TARGET)-tcc$(EXESUF)

I386_O = libtcc1.o alloca86.o alloca86-bt.o
X86_64_O = libtcc1.o alloca86_64.o
WIN32_O = $(I386_O) crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o bcheck.o
WIN64_O = $(X86_64_O) crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o

VPATH = $(TOP)/lib $(TOP)/win32/lib

ifeq "$(TARGET)" "i386-win32"
 OBJ = $(addprefix $(DIR)/,$(WIN32_O))
 TGT = -DTCC_TARGET_I386 -DTCC_TARGET_PE
 XCC = $(TCC) -B$(TOP)/win32 -I$(TOP)/include
 XAR = $(DIR)/tiny_libmaker$(EXESUF)
else
ifeq "$(TARGET)" "x86_64-win32"
 OBJ = $(addprefix $(DIR)/,$(WIN64_O))
 TGT = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE
 XCC = $(TCC) -B$(TOP)/win32 -I$(TOP)/include
 XAR = $(DIR)/tiny_libmaker$(EXESUF)
else
ifeq "$(TARGET)" "i386"
 OBJ = $(addprefix $(DIR)/,$(I386_O))
 TGT = -DTCC_TARGET_I386
 XCC ?= $(TCC) -B$(TOP)
else
ifeq "$(TARGET)" "x86_64"
 OBJ = $(addprefix $(DIR)/,$(X86_64_O))
 TGT = -DTCC_TARGET_X86_64
 XCC ?= $(TCC) -B$(TOP)
else
 $(error libtcc1.a not supported on target '$(TARGET)')
endif
endif
endif
endif

ifdef XAR
AR = $(XAR)
endif

$(DIR)/libtcc1.a ../libtcc1.a : $(OBJ) $(XAR)
	$(AR) rcs $@ $(OBJ)
$(DIR)/%.o : %.c
	$(XCC) -c $< -o $@ $(TGT)
$(DIR)/%.o : %.S
	$(XCC) -c $< -o $@ $(TGT)
$(DIR)/%$(EXESUF) : $(TOP)/win32/tools/%.c
	$(CC) -Os -s -w -o $@ $< $(TGT)

$(OBJ) $(XAR) : $(DIR)/exists
$(DIR)/exists :
	mkdir -p $(DIR)
	@echo $@ > $@

clean :
	rm -rfv i386-win32 x86_64-win32 i386 x86_64

=== tests/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 # run local version of tcc with local libraries and includes
 TCC = ../tcc -B..
-RUN_TCC = $(NATIVE_DEFINES) -run ../tcc.c -B..
+RUN_TCC = $(NATIVE_DEFINES) -run -DONE_SOURCE ../tcc.c -B..
 DISAS=objdump -d
 
 all test : $(TESTS)

=== debian/changelog ===
tcc (0.9.26~git20120104.83d57c0-2) experimental; urgency=low

  * Fix armel FTBFS by not compiling tccasm.c, as inline assembly is not
    supported on armel (Closes: #654904).

 -- Thomas Preud'homme <robotux@celest.fr>  Fri, 06 Jan 2012 18:37:50 +0100

tcc (0.9.26~git20120104.83d57c0-1) experimental; urgency=low

  * New upstream snapshot:
    + Make tcc search crt*.o files at the right location (Closes: #654631).
    + Incorporate the fix for linkage of named file in loader script
      (Closes: #654528).
  * debian/control:
    + Convert libtcc-dev to multiarch.
  * debian/rules:
    + Adapt to the new upstream build system.

 -- Thomas Preud'homme <robotux@celest.fr>  Thu, 05 Jan 2012 15:45:51 +0100

tcc (0.9.25-13) unstable; urgency=low

  * Fix linkage of named file in loader script (Closes: #654528).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 04 Jan 2012 16:50:01 +0100

tcc (0.9.25-12) unstable; urgency=medium

  * Correct size_t and ptrdiff_t type on amd64 (Closes: #654436).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 04 Jan 2012 11:30:56 +0100

tcc (0.9.25-11) unstable; urgency=medium

  * Change ELF interpreter from /lib/ld-linux-x86-64.so.2 — contrary to what
    announces previous entry — to /lib64/ld-linux-x86-64.so.2
    (Closes: #653941).

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 03 Jan 2012 15:53:32 +0100

tcc (0.9.25-10) unstable; urgency=medium

  * Stop wrongly using multiarch dynamic loader as elf interpreter, eg. back
    to use /lib64/ld-linux-x86-64.so.2 for amd64 (Closes: #636541).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 03 Aug 2011 18:04:35 +0200

=== debian/control ===
--- 
+++ 
@@ -31,6 +31,7 @@
 Package: libtcc-dev
 Section: libdevel
 Architecture: any-i386 any-amd64 armel
+Multi-Arch: same
 Depends: ${misc:Depends}
 Description: Fast library for dynamic code generation
  Libtcc is a library that uses tcc, a compiler several times faster than

## tcc 0.9.26~git20120612.ad5f375

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,7 @@
 endif
 endif
 
+ifneq ($(TARGETOS),Darwin)
 ifeq ($(ARCH),i386)
 CFLAGS+=-mpreferred-stack-boundary=2
 ifeq ($(GCC_MAJOR),2)
@@ -23,6 +24,7 @@
 CFLAGS+=-march=i386 -falign-functions=0
 endif
 endif
+endif
 
 ifdef CONFIG_WIN64
 CONFIG_WIN32=yes
@@ -36,11 +38,15 @@
 endif
 
 ifeq ($(ARCH),i386)
-NATIVE_DEFINES=-DTCC_TARGET_I386
+NATIVE_DEFINES=-DTCC_TARGET_I386 
+NATIVE_DEFINES+=$(if $(wildcard /lib/i386-linux-gnu),-DCONFIG_MULTIARCHDIR=\"i386-linux-gnu\")
+CFLAGS+=-m32
 else
 ifeq ($(ARCH),x86-64)
 NATIVE_DEFINES=-DTCC_TARGET_X86_64
-NATIVE_DEFINES+=$(if $(wildcard /lib64/ld-linux-x86-64.so.2),-DTCC_TARGET_X86_64_CENTOS)
+CFLAGS+=-m64
+NATIVE_DEFINES+=$(if $(wildcard /usr/lib64),-DCONFIG_LDDIR=\"lib64\")
+NATIVE_DEFINES+=$(if $(wildcard /lib/x86_64-linux-gnu),-DCONFIG_MULTIARCHDIR=\"x86_64-linux-gnu\")
 endif
 endif
 
@@ -48,7 +54,10 @@
 NATIVE_DEFINES=-DTCC_TARGET_ARM
 NATIVE_DEFINES+=-DWITHOUT_LIBTCC
 NATIVE_DEFINES+=$(if $(wildcard /lib/ld-linux.so.3),-DTCC_ARM_EABI)
+NATIVE_DEFINES+=$(if $(wildcard /lib/arm-linux-gnueabi),-DCONFIG_MULTIARCHDIR=\"arm-linux-gnueabi\")
 NATIVE_DEFINES+=$(if $(shell grep -l "^Features.* \(vfp\|iwmmxt\) " /proc/cpuinfo),-DTCC_ARM_VFP)
+# To use ARM hardfloat calling convension
+#NATIVE_DEFINES+=-DTCC_ARM_HARDFLOAT
 endif
 
 ifdef CONFIG_WIN32
@@ -136,6 +145,10 @@
 ifdef CONFIG_UCLIBC
 BCHECK_O=
 endif
+ifeq ($(TARGETOS),Darwin)
+BCHECK_O=
+PROGS+=tiny_libmaker$(EXESUF)
+endif
 
 ifdef CONFIG_USE_LIBGCC
 LIBTCC1=
@@ -153,7 +166,7 @@
 
 # Host Tiny C Compiler
 tcc$(EXESUF): tcc.o $(LIBTCC)
-	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS) $(LINK_LIBTCC)
+	$(CC) -o $@ $^ $(LIBS) $(CFLAGS) $(LDFLAGS) $(LINK_LIBTCC)
 
 # Cross Tiny C Compilers
 %-tcc$(EXESUF):
@@ -190,7 +203,7 @@
 else
 LIBTCC_OBJ = libtcc.o
 LIBTCC_INC = $(NATIVE_FILES)
-$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DONE_SOURCE
+libtcc.o : NATIVE_DEFINES += -DONE_SOURCE
 endif
 
 $(LIBTCC_OBJ) tcc.o : %.o : %.c $(LIBTCC_INC)

=== lib/Makefile ===
--- 
+++ 
@@ -14,11 +14,15 @@
  else
  ifeq ($(ARCH),i386)
   TARGET = i386
-  XCC = gcc -O2
+	ifneq ($(TARGETOS),Darwin)
+		XCC = gcc -O2 -m32
+	endif
  else
  ifeq ($(ARCH),x86-64)
   TARGET = x86_64
-  XCC = gcc -O2
+	ifneq ($(TARGETOS),Darwin)
+		XCC = gcc -O2 -m64
+	endif
  endif
  endif
  endif
@@ -55,12 +59,18 @@
 ifeq "$(TARGET)" "i386"
  OBJ = $(addprefix $(DIR)/,$(I386_O))
  TGT = -DTCC_TARGET_I386
- XCC ?= $(TCC) -B$(TOP)
+ XCC ?= $(TCC) -B$(TOP) -m32 -D_ANSI_SOURCE
+ ifeq ($(TARGETOS),Darwin)
+  XAR = $(DIR)/tiny_libmaker$(EXESUF)
+ endif
 else
 ifeq "$(TARGET)" "x86_64"
  OBJ = $(addprefix $(DIR)/,$(X86_64_O))
  TGT = -DTCC_TARGET_X86_64
- XCC ?= $(TCC) -B$(TOP)
+ XCC ?= $(TCC) -B$(TOP) -m64 -D_ANSI_SOURCE
+ ifeq ($(TARGETOS),Darwin)
+  XAR = $(DIR)/tiny_libmaker$(EXESUF)
+ endif
 else
  $(error libtcc1.a not supported on target '$(TARGET)')
 endif

=== tests/Makefile ===
--- 
+++ 
@@ -16,6 +16,12 @@
 
 ifdef DISABLE_STATIC
 export LD_LIBRARY_PATH:=$(CURDIR)/..
+endif
+
+ifeq ($(TARGETOS),Darwin)
+CFLAGS+=-Wl,-flat_namespace,-undefined,warning
+export MACOSX_DEPLOYMENT_TARGET:=10.2
+NATIVE_DEFINES+=-D_ANSI_SOURCE
 endif
 
 # run local version of tcc with local libraries and includes
@@ -45,7 +51,7 @@
 # test.ref - generate using gcc
 # copy only tcclib.h so GCC's stddef and stdarg will be used
 test.ref: tcctest.c
-	cp -u ../include/tcclib.h .
+	cp ../include/tcclib.h .
 	$(CC) -o tcctest.gcc $< -I. -w $(CFLAGS) -std=gnu99
 	./tcctest.gcc > $@

=== debian/changelog ===
tcc (0.9.26~git20120612.ad5f375-6) unstable; urgency=low

  [Paul Tagliamonte]
    * Uploading Tom's fixes on his behalf. Although he's signed this upload
      (he issued a debdiff), I've prepared this upload. Fix verified on
      i386.

  [Thomas Preud'homme]
    * debian/patches:
      + Fix incorrect reading of long long values on architecture with 32bits
        registers like i386 and armel (Closes: #681281).

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 21 Jul 2012 03:43:35 +0200

tcc (0.9.26~git20120612.ad5f375-5) unstable; urgency=low

  * debian/patches:
    + Correctly handle integer promotion in patch fixing incorrect shift
      result type (Closes: #679123).
  * debian/control:
    + Set myself as Maintainer instead of Aurélien Gérôme as a result of him
      being MIA (Closes: #677782).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 08 Jul 2012 17:36:15 +0200

tcc (0.9.26~git20120612.ad5f375-4) unstable; urgency=low

  * debian/patches:
    + Cherry-pick patch fixing incorrect shift result type (Closes: #679123).
  * debian/control:
    + Update Vcs-Browser URL.

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 27 Jun 2012 15:14:25 +0200

tcc (0.9.26~git20120612.ad5f375-3) unstable; urgency=low

  * debian/patches:
    + Disable the new callsave_test test on arm since it uses alloca which is
      not supported on arm (yet).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 13 Jun 2012 22:31:30 +0200

tcc (0.9.26~git20120612.ad5f375-2) unstable; urgency=low

  * debian/patches:
    + Correctly handle multiarch on Kfreebsd and Hurd.

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 13 Jun 2012 18:34:11 +0200

tcc (0.9.26~git20120612.ad5f375-1) unstable; urgency=low

  * New upstream snapshot
  * debian/patches:
    + Fix R_ARM_REL32 relocation.
    + Expands arguments of configure script in order to accept ${prefix}.
  * debian/control:
    + Remove initial capital in package synopsis.
    + Update build dependency version on debhelper to reflect compatibility.
  * debian/rules:
    + Adapt to new upstream build system.
    + Remove build flags export as debhelper already does it.
    + Remove useless comments.
  * Bump compatibility to 9.
  * Add lintian overrides:
    + Upstream explicitly disable functions fortification, so do we.
    + Scripts in /usr/share/doc/tcc/examples are examples and need thus to be
      modified before used.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 12 Jun 2012 18:06:17 +0200

tcc (0.9.26~git20120104.83d57c0-5) unstable; urgency=low

  * Document that -b is only available on i386 (Closes: #663692).
  * Correctly parse unsigned long constants (ex: 1UL) on amd64
    (Closes: #663711).
  * Support arguments to linker options to be passed in separate linker
    options as in -Wl,-rpath -Wl,<somedir> (Closes: #663693).

 -- Thomas Preud'homme <robotux@celest.fr>  Thu, 15 Mar 2012 00:39:47 +0100

tcc (0.9.26~git20120104.83d57c0-4) unstable; urgency=low

  * Upload to unstable.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 06 Mar 2012 00:19:03 +0100

tcc (0.9.26~git20120104.83d57c0-3) experimental; urgency=low

  * Fix typo of an error about unknown size with bounded pointer arithmetic
    (Closes: #655110, thanks Urs Janssen).
  * Fix loading of LLOCAL floats (Closes: #656995).
  * Use version 1.0 for DEP5 copyright.
  * Bump Standards-Version to 3.9.3 (no changes needed).

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 05 Mar 2012 23:13:42 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: tcc
 Section: devel
 Priority: optional
-Maintainer: Aurélien GÉRÔME <ag@debian.org>
-Uploaders: Thomas Preud'homme <robotux@celest.fr>, Arthur Loiret <arthur.loiret@gmail.com>
-Build-Depends: debhelper (>= 8.1.3), texi2html, texinfo, perl
-Standards-Version: 3.9.2
+Maintainer: Thomas Preud'homme <robotux@celest.fr>
+Uploaders: Arthur Loiret <arthur.loiret@gmail.com>
+Build-Depends: debhelper (>= 9), texi2html, texinfo, perl
+Standards-Version: 3.9.3
 Homepage: http://www.tinycc.org/
 DM-Upload-Allowed: yes
-Vcs-Browser: http://anonscm.debian.org/git/collab-maint/tcc.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tcc.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/tcc.git
 
 Package: tcc
@@ -15,7 +15,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libc6-dev | libc-dev
 Provides: c-compiler
-Description: Small ANSI C compiler
+Description: small ANSI C compiler
  TCC (for Tiny C Compiler) is a small and fast ANSI C compiler.  It
  generates optimized x86 code, and can compile, assemble, and link
  several times faster than 'gcc -O0'.  Any C dynamic library can be used
@@ -33,7 +33,7 @@
 Architecture: any-i386 any-amd64 armel
 Multi-Arch: same
 Depends: ${misc:Depends}
-Description: Fast library for dynamic code generation
+Description: fast library for dynamic code generation
  Libtcc is a library that uses tcc, a compiler several times faster than
  'gcc -O0' to perform dynamic code generation. It exposes in its API all
  operations tcc performs to generate a binary from sources: setting

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- --tccdir=../tcc

override_dh_auto_clean:
	[ ! -f config.mak ] || dh_auto_clean

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build # As recommended by policy §4.9

%:
	dh $@

=== debian/watch ===
version=3

http://download.savannah.nongnu.org/releases/tinycc/tcc-([\d\.]+).tar.bz2 debian uupdate

## tcc 0.9.26%7egit20120104.83d57c0

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: tcc
 Section: devel
 Priority: optional
-Maintainer: Thomas Preud'homme <robotux@celest.fr>
-Uploaders: Arthur Loiret <arthur.loiret@gmail.com>
-Build-Depends: debhelper (>= 9), texi2html, texinfo, perl
+Maintainer: Aurélien GÉRÔME <ag@debian.org>
+Uploaders: Thomas Preud'homme <robotux@celest.fr>, Arthur Loiret <arthur.loiret@gmail.com>
+Build-Depends: debhelper (>= 8.1.3), texi2html, texinfo, perl
 Standards-Version: 3.9.3
 Homepage: http://www.tinycc.org/
 DM-Upload-Allowed: yes
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tcc.git
+Vcs-Browser: http://anonscm.debian.org/git/collab-maint/tcc.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/tcc.git
 
 Package: tcc
@@ -15,7 +15,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libc6-dev | libc-dev
 Provides: c-compiler
-Description: small ANSI C compiler
+Description: Small ANSI C compiler
  TCC (for Tiny C Compiler) is a small and fast ANSI C compiler.  It
  generates optimized x86 code, and can compile, assemble, and link
  several times faster than 'gcc -O0'.  Any C dynamic library can be used
@@ -33,7 +33,7 @@
 Architecture: any-i386 any-amd64 armel
 Multi-Arch: same
 Depends: ${misc:Depends}
-Description: fast library for dynamic code generation
+Description: Fast library for dynamic code generation
  Libtcc is a library that uses tcc, a compiler several times faster than
  'gcc -O0' to perform dynamic code generation. It exposes in its API all
  operations tcc performs to generate a binary from sources: setting

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	[ ! -f config.mak ] || dh_auto_clean

override_dh_auto_configure:
	./configure --prefix=/usr \
		--tccdir=../tcc \
		--docdir=/usr/share/doc/tcc \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--crtprefix=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--sysincludepaths=/usr/local/include:/usr/include/$(DEB_HOST_MULTIARCH):/usr/include:{B}/include \
		--libpaths=/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib:/lib/$(DEB_HOST_MULTIARCH):/lib:/usr/local/lib

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build # As recommended by policy §4.9

%:
	dh $@
